#!/usr/bin/awk -f
# computes mean square displacement in replica units DREP^2
# The round trip time is given by the 
# formula DREP^2(t) = 2Dt; D = DREP^2(t)/2*t and t_{rt} = Nrep^2/(2D)  
BEGIN{Nrepmax=0; told=0; DR=0}
{if(NR>1) {
rep[NR]=$2
if(rep[NR]> Nrepmax) {Nrepmax=rep[NR]}
dt=$1-told; told=$1
    }
} 
END{  
    for( j=1; j<=NR-1; j++ ){ 
	xrep[j]=0.0;	
	for(i=1; i<=NR-j; i++) 
	{
	    xrep[j]+=rep[i+j]^2+rep[i]^2 - 2*rep[i+j]*rep[i]
	}
	xrep[j]=xrep[j]/(NR-j)
        DR+=xrep[j]/(2*j)
	drav=DR/j
#	print j,drav,xrep[j],xrep[j]/(2*j) 
    } 
    D=xrep[int(NR/2)]/(NR) ; rt = Nrepmax^2/(2*drav)
    print "# Diffusion (Replica units per ps) =", drav*(1000./dt); 
    print "# Predicted Roint-Trip Time in ps  =", 2*rt*dt/1000. 
}
