#!/usr/bin/awk -f
#
# this program extracts a single replica-state from a HREM/REM trajectory file
#
# syntax:
# $ get_replica_pdfile.awk [-v nrep=replica_index] xyzfile
#
# replica_index: integer indicating the replica state (if not given, nrep=1)
# pdbfile: HREM pdb trajectory
#
#
# set the default target replica 
BEGIN{
    if(nrep==0) {nrep=1}
}

# scan the file and select only replica=nrep

{   if(NR==1) {print}
    if($1=="Time:") {
	if($NF==nrep) {
	    prt =1
	}
	else {
	    prt=0
	}
#	print nrep,prt,$NF
    }
    if(prt==1) {ip++; lines[ip]=$0}
}
# last 2 lines is the number of atoms and number of records 
END{
    for(i=1; i<=ip-1; i++) {
	print lines[i]
    }
} 
